/*

 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with MichalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef COMPINCREASINGARRAY_HPP_
#define COMPINCREASINGARRAY_HPP_

#include "StdAfx.h"

class MyIncreasingArray;

namespace ngramchecker {

	typedef boost::shared_ptr<pair<uint32_t, uint32_t> > CompIA_First_Last_IndexPair;

	class CompIncreasingArray {
	private:
		vector<boost::shared_ptr<MyIncreasingArray> > mia_vec;

		uint32_t size_of_parts;
		uint32_t num_values;

		uint32_t last_val_last_index;

	public:
		uint32_t GetSize();

		uint32_t GetValueAt(uint32_t i);

		CompIA_First_Last_IndexPair GetFirstLastIndexPair(uint32_t i);

		void WriteToStream(ofstream &ofs);

		CompIncreasingArray(ifstream &ifs);

		CompIncreasingArray(vector<uint32_t> &val, uint32_t _last_val_last_index);
	};

	SP_DEF(CompIncreasingArray);
}

#endif /* COMPINCREASINGARRAY_HPP_ */
