/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef DECODERMORPHOANAL_HPP_
#define DECODERMORPHOANAL_HPP_

#include "StdAfx.h"
#include "DecoderBase.hpp"


namespace ngramchecker {

	class DecoderMorphoAnal : public DecoderBase
	{
	private:

		double lemma_weight;
		double tag_weight;

		virtual vector<vector<StagePosibilityP> > init_inner_stage_posibilities(vector<Token> &tokens);

	public:
		DecoderMorphoAnal(uint32_t _viterbi_order, double _lemma_weight, double _tag_weight);

	};


}

#endif /* DECODERMORPHOANAL_HPP_ */
