/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef DECODERMULTIFACTOR_HPP_
#define DECODERMULTIFACTOR_HPP_

#include "StdAfx.h"
#include "DecoderBase.hpp"

namespace ngramchecker {

	class SimWordsFinder;
	SP_DEF(SimWordsFinder);

	class DecoderMultiFactor : public DecoderBase
	{
	private:

		double form_model_weight;
		double lemma_model_weight;
		double tag_model_weight;

		SimWordsFinderP simWordsFinder;

		virtual vector<vector<StagePosibilityP> > init_inner_stage_posibilities(vector<Token> &tokens);

	public:
		DecoderMultiFactor(uint32_t form_lm_order, uint32_t lemma_lm_order, uint32_t tag_lm_order, SimWordsFinderP _simWordsFinder, double _form_model_weight, double _lemma_model_weight, double _tag_model_weight);

	};

}

#endif /* DECODERMULTIFACTOR_HPP_ */
