/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef EVALUATION_HPP_
#define EVALUATION_HPP_

#include "StdAfx.h"
#include "DecoderLetter.hpp"

namespace ngramchecker {

	class ErrorModel;
	SP_DEF(ErrorModel);

	class Evaluation {
	public:

		static string EvaluateCorrectionFormsOnly(string out_dir, string dataset, bool ignore_case, double _form_weight, uint32_t _form_order);

		static void EvaluateCorrectionMultiFactor(string out_dir, string dataset, double form_weight, double lemma_weight, double tag_weight, bool ignore_case, uint32_t form_lm_order, uint32_t lemma_lm_order, uint32_t tag_lm_order);

		static void EvaluateDiacriticFormsOnly(string out_dir, string dataset, ErrorModelP error_model, bool ignore_case, LetterLMSettings llms, double _form_weight, uint32_t _form_order);

		static string EvaluateDiacriticMultiFactor(string out_dir, string dataset, ErrorModelP error_model, double form_weight, double lemma_weight, double tag_weight, bool ignore_case, LetterLMSettings llms, uint32_t form_lm_order, uint32_t lemma_lm_order, uint32_t tag_lm_order);

		static string EvaluateTagger(string dataset);
	};

}
#endif /* EVALUATION_HPP_ */
