/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef LMSERVER_HPP_
#define LMSERVER_HPP_

#include "StdAfx.h"

namespace ngramchecker {

	class LMWrapper;
	SP_DEF(LMWrapper);

	class NGram;
	SP_DEF(NGram);

	class LMServer {

	private:
		vector<LMWrapperP> lmWrappers;

		LMWrapperP letter_common_lmWrapper;
		LMWrapperP letter_names_lmWrapper;

	public:
		LMServer();

		double GetNextWordCost(uint32_t factor_number, NGramP ngram_key);

		double GetContextFreeCost(uint32_t word_ID);

		double GetNextLetterCost_names(NGramP letter_ngram_key);

		double GetNextLetterCost_common(NGramP letter_ngram_key);

		bool ExistFormBigram(uint32_t next_form_id, uint32_t prev_form_id);

		double GetMaxUnigramID(uint32_t factor);

		void ClearCash();

		void PrintStats();

	};



	//LMServer lmServer;


}

#endif /* LMSERVER_HPP_ */
