/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef LMWRAPPER_HPP_
#define LMWRAPPER_HPP_

#include "StdAfx.h"
#include "NGram.hpp"

namespace ngramchecker {

	typedef unordered_set<NGramP, NGramP_ihash, NGramP_iequal_to> NGram_cash_type;

	class LMWrapper {
	public:

		virtual double GetProb(NGramP ngram_key) = 0;
		virtual void ClearCash() = 0;
		virtual bool ContainsNGram(NGramP ngram_key) = 0;
		virtual void PrintStats() = 0;
		virtual uint32_t MaxUnigramID() = 0;

	};

	SP_DEF(LMWrapper);

}

#endif /* LMWRAPPER_HPP_ */
