/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef LMWRAPPER_ZIPLM_HPP_
#define LMWRAPPER_ZIPLM_HPP_

#include "StdAfx.h"
#include "MyCash.hpp"
#include "LMWrapper.hpp"

namespace ngramchecker {

	class ZipLM;
	SP_DEF(ZipLM);

	typedef MyCash<NGramP, NGramP, NGramP_ihash, NGramP_iequal_to> MyCash_NGramP;
	typedef MyCash<NGramP, double, NGramP_ihash, NGramP_iequal_to> MyCash_NGramProbs;

	class LMWrapper_ZipLM : public LMWrapper {
	private:

		ZipLMP LM;
		//NGram_cash_type ngram_cash;
		//NGram_cash_type fail_ngram_cash;

		//unordered_set<uint32_t> cashed_ids;

		uint32_t _lookups;
		uint32_t _hits;

		MyCash_NGramP ngram_cash;
		MyCash_NGramProbs ngram_probs_cash;

		NGramP GetNGram(NGramP ngram_key);

	public:

		LMWrapper_ZipLM(ZipLMP _LM, uint32_t ngram_cash_capacity, uint32_t ngram_probs_cash_capacity);

		double GetProb_old(NGramP ngram_key);

		virtual double GetProb(NGramP ngram_key);
		virtual void ClearCash();
		virtual bool ContainsNGram(NGramP ngram_key);
		virtual void PrintStats();
		virtual uint32_t MaxUnigramID();

	};

}

#endif /* LMWRAPPER_ZIPLM_HPP_ */
