/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef _LEXICON_ARC_
#define _LEXICON_ARC_

#include "StdAfx.h"

namespace ngramchecker {

	class LexiconArc {
	 public:

	  char character;
	  uint32_t nextstate;


	  LexiconArc(char _character, uint32_t _nextstate)
		  : character(_character), nextstate(_nextstate) {}

	  bool operator<(const LexiconArc& val) const;
	};

	typedef boost::shared_ptr<vector<LexiconArc> > vectorP_LexiconArc;

}


#endif //_LEXICON_ARC_
