/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef MYMAPPEDDOUBLEARRAY_HPP_
#define MYMAPPEDDOUBLEARRAY_HPP_

#include "StdAfx.h"

namespace ngramchecker {

	class ValueMapping;
	SP_DEF(ValueMapping);

	class MyPackedArray;
	SP_DEF(MyPackedArray);

	class MyMappedDoubleArray {
	private:
		ValueMappingP value_mapping;
		MyPackedArrayP mpa;

	public:
		uint32_t GetSize();

		double GetValueAt(uint32_t index);

		void WriteToStream(ofstream &ofs);

		MyMappedDoubleArray(vector<double> &values, uint32_t bits_per_value);

		MyMappedDoubleArray(ifstream &ifs);
	};

	SP_DEF(MyMappedDoubleArray);
}

#endif /* MYMAPPEDDOUBLEARRAY_HPP_ */
