/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef _MY_PACKED_ARRAY_HPP_
#define _MY_PACKED_ARRAY_HPP_

#include "StdAfx.h"

namespace ngramchecker {

	class MyPackedArray {
		private:
			uint32_t bits_per_value;
			uint32_t num_values;
			uint32_t num_bytes;
			unsigned char* data;
			uint32_t output_mask;



		public:

			void PrintBits();

			uint32_t GetSize();

			uint32_t GetNumberOfBytes();

			uint32_t GetBitsPerValue();

			uint32_t GetValueAt(uint32_t index);

			~MyPackedArray();

			MyPackedArray(const MyPackedArray& val);

			MyPackedArray& operator=(const MyPackedArray& val);

			MyPackedArray(ifstream &ifs);

			MyPackedArray(const string filename);

			void WriteToStream(ofstream &ofs);

			void SaveToFile(const string filename);

			MyPackedArray(const vector<uint32_t> &values);
	};

	SP_DEF(MyPackedArray);

}

#endif //_MY_PACKED_ARRAY_HPP_
