/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef SIM_WORDS_FINDER_HPP_
#define SIM_WORDS_FINDER_HPP_

#include "StdAfx.h"

namespace ngramchecker {
	
	class Token;
	class ErrorModel;
	SP_DEF(ErrorModel);

	class SimWordsFinder {
	public:
		ErrorModelP errModel;

	protected:


		SimWordsFinder(ErrorModelP _errModel):
			errModel(_errModel)
		{}

		Similar_Words_Map Find_basic(Token &token, bool sentence_start, uint32_t lookup_max_ed_dist, double lookup_max_cost);

		Similar_Words_Map Find_basic_ignore_case(string &word_str, bool sentence_start, bool keep_orig_casing, uint32_t lookup_max_ed_dist, double lookup_max_cost);

	public:
		virtual Similar_Words_Map Find(Token &token, bool sentence_start) = 0;
	};

	SP_DEF(SimWordsFinder);
}

#endif /* SIM_WORDS_FINDER_HPP_ */
