/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef SIM_WORDS_FINDER_DIACRITIC_HPP_
#define SIM_WORDS_FINDER_DIACRITIC_HPP_

#include "StdAfx.h"
#include "SimWordsFinder.hpp"
#include "DecoderLetter.hpp"

namespace ngramchecker {


	class SimWordsFinderDiacritic : public SimWordsFinder {
	private:

		//dummy constants, because Diacritic error models add no edit distance when diacritic changed
		static const uint32_t errModel_max_ed_dist;
		static const double errModel_max_cost;

		static const bool debug = true;

		bool perform_similar_words_search_ignore_case;

		LetterLMSettings llms;


	public:

		SimWordsFinderDiacritic(ErrorModelP _errModel, bool _sim_words_search_ignore_case, LetterLMSettings _llms);

		virtual Similar_Words_Map Find(Token &token, bool sentence_start);
	};

	SP_DEF(SimWordsFinderDiacritic);

}

#endif /* OOV_RESOLVER_DIACRITIC_HPP_ */
