/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef SPELLCHECKER_HPP_
#define SPELLCHECKER_HPP_

#include "StdAfx.h"
#include "StagePosibility.hpp"
#include "DecoderBase.hpp"

namespace ngramchecker {

	//class StagePosibility;
	//SP_DEF(StagePosibility);
	
	class TransitionCostComputation;
	SP_DEF(TransitionCostComputation);

	class TextCheckingResult;
	SP_DEF(TextCheckingResult);

	//class DecoderBase;
	//SP_DEF(DecoderBase);


	class Spellchecker {

		boost::shared_ptr<DecoderBase> decoder;
		TransitionCostComputationP transition_cost_computation;

		map<uint32_t, vector<StagePosibilityP> > MakeSuggestionList(vector<StagePosibilityP> &decoded_pos, StagePosibilitiesType stage_posibilities);	public:

		vector<TextCheckingResultP> GetCheckingResults(string sentence);

		string CheckSentence(const string sentence);

		string DecodeEvaluation(const string sentence, uint32_t num_sugg_to_output);
		
		string command_line_mode(const string sentence, uint32_t num_sugg_to_output);

		Spellchecker(DecoderBaseP _decoder);

	};

}

#endif /* SPELLCHECKER_HPP_ */
