/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef SPLITTER_HPP_
#define SPLITTER_HPP_

#include "StdAfx.h"

namespace ngramchecker {

	class Splitter {
	private:
		Splitter() {}

		enum SentenceSplitterState { noState, insideSentence, possibleEnding, addToDelimSeq, finishSentence };

		enum TokenizerState { insideToken, outsideToken };

	public:


		static void SplitWordToLetters(string word, vector<string> &tokens, vector<string> &delim_seqs);

		static void SplitSentenceToTokens(string sentence, vector<string> &tokens, vector<string> &delim_seqs);

		static void SplitTextToSentences(string text, vector<string> &sentences, vector<string> &delim_seqs);
	};

}

#endif /* SPLITTER_HPP_ */
