/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef _VALUE_MAPPING_HPP_
#define _VALUE_MAPPING_HPP_

#include "StdAfx.h"

namespace ngramchecker {


	class ValueMapping {
	private:
		vector<double> sorted_centers;


	public:

		double GetDouble(uint32_t centerID);

		uint32_t GetCenterID(double value);

		void writeToStream(ofstream &ofs);

		ValueMapping(vector<double> centers);

		static ValueMapping* readFromStream(ifstream &ifs);

		ValueMapping(vector<double> values, const uint32_t bits_per_value);

	};

	SP_DEF(ValueMapping);
}

#endif //_VALUE_MAPPING_HPP_
