/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#include "utils.hpp"

namespace ngramchecker {

	double MyUtils::RandomNumber(double min, double max)
	{
		return ((double)rand() / RAND_MAX) * (max - min) + min;
	}
		
	int MyUtils::randomR(int lowest, int range)
	{
		uint32_t ret = lowest+uint32_t(range*(rand()/(RAND_MAX + (float)1.0)));
		return ret;
	}

	double MyUtils::minus_log_10_rand01()
	{
		double rand_num = -log10(rand() / (float)RAND_MAX);
		return rand_num;
	}


	void MyUtils::cerr_vector_string(const vector<string> &vec)
	{
		for (uint32_t i = 0; i < vec.size(); i++)
		{
			if (i > 0) cerr << endl;
			cerr << vec[i];
		}
		cerr << endl;
	}

	string MyUtils::GetTimeString()
	{
		string ret;

		time_t rawtime;

	    time ( &rawtime );

		string time_str = ctime(&rawtime);

		ret = time_str.substr(4, 3) + "-" + time_str.substr(8, 2) + "_" + time_str.substr(11, 2) + "-" + time_str.substr(14, 2);

		return ret;
	}

	bool MyUtils::StrToBool(string str)
	{
		if (str == "true")
			return true;
		else if (str == "false")
			return false;
		else
		{
			cerr << "str -> bool conversion failed!" << endl;
			exit(1);
		}
	}

	double MyUtils::StrToDouble(string str)
	{
		return boost::lexical_cast<double>(str);
	}

	uint32_t MyUtils::StrToInt(string str)
	{
		return boost::lexical_cast<uint32_t>(str);
	}


	string MyUtils::BoolToString(bool value)
	{
		if (value)
			return "true";
		else
			return "false";
	}
}