/*
 
 Copyright (C) 2010 Michal Richter (michalisek@gmail.com)
 
 This file is part of michalisekSpell.
 
 MichalisekSpell is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 3 of the License, or (at your
 option) any later version.
 
 MichalisekSpell is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 for more details.
 
 You should have received a copy of the GNU General Public License
 along with michalisekSpell; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */

#ifndef MICHALISEKSPELL_UTILS_HPP_
#define MICHALISEKSPELL_UTILS_HPP_

#include "StdAfx.h"

#define FATAL_CONDITION(expr, error_text) if (!(expr)) { std::cerr << "FATAL ERROR! The condition ( " << #expr << " ) failed. " << error_text << std::endl; string dummy_string; std::cin >> dummy_string; exit(-1); } 

namespace ngramchecker {

	class MyUtils {
	public:
		
		static double RandomNumber(double min, double max);
		
		static int randomR(int lowest, int range);

		static double minus_log_10_rand01();

		static uint32_t BitsNeeded(uint32_t value)
		{
			uint32_t ret = 0;
			uint32_t pom = 1;
			while (pom <= value)
			{
				ret++;
				pom = pom << 1;
			}

			return ret;
		}

		static void cerr_vector_string(const vector<string> &vec);

		static string GetTimeString();

		static bool StrToBool(string str);

		static double StrToDouble(string str);

		static uint32_t StrToInt(string str);

		static string BoolToString(bool value);

	};
}

#endif /* MICHALISEKSPELL_UTILS_HPP_ */
